
/**************************************************************
*
* draw.h header: methods drawing
*
**************************************************************/

 
#ifndef __DRAW_H__
#define __DRAW_H__

 /***********************************************************************
 * included headers some global stuff
 ***********************************************************************/

#include <nds.h>
#include <math.h>

#define RGBColor(r,g,b) (b<<10|g<<5|r) 

#define RADTODEG(x) ((x) * 57.29578)
#define DEGTORAD(x) ((x) / 57.29578)
#define min(a,b) ((a)>(b)?(b):(a))
#define max(a,b)  ({ typeof (a) _a = (a);  typeof (b) _b = (b);  _a > _b ? _a : _b; })


#define PIXEL(x)			(x | (1 << 15))

#define COLOR_RED			PIXEL(RGB15(31, 0, 0))
#define COLOR_GREEN			PIXEL(RGB15(0, 31, 0))
#define COLOR_BLUE			PIXEL(RGB15(0, 0, 31))
#define COLOR_YELLOW		PIXEL(RGB15(31, 31, 0))
#define COLOR_CYAN			PIXEL(RGB15(0, 31, 31))
#define COLOR_BLACK			PIXEL(RGB15(0, 0, 0))
#define COLOR_WHITE			PIXEL(RGB15(31, 31, 31))
#define COLOR_SCORE_LARGE	PIXEL(SCORE_LARGE_DATA[0])
#define COLOR_SCORE_SMALL	PIXEL(


#include "click1_img_bin.h"


extern void drawBall( u16* video_buffer, int x1, int y1, float myRadius , u16 color);
extern void drawBackBall( u16* video_buffer_Source, u16* video_buffer_Dest, int x1, int y1, float myRadius);

float dist ( int i, int j,  int mx, int my );

extern void drawLine( u16* video_buffer, int x1, int y1, int x2, int y2 );

inline void drawPixel(u16 *video_buffer, u16 x, u16 y, u16 color);
inline u16 getPixel(u16 *video_buffer, u16 x, u16 y);

void drawRotatedBitMap(u16* video_buffer_Source, u16* video_buffer_Dest, u16 bufferX, u16 bufferY, u16* bitmap, u8 bitmapX, u8 bitmapY, u16 width, u8 height, float angle);
void drawBitmapWithBlanks(u16* video_buffer_Source, u16* video_buffer_Dest, u16 bufferX, u16 bufferY, u16* bitmap, u8 bitmapX, u8 bitmapY, u16 width, u8 height, float angle);

int sign( int intmyNumber );
int pointInTriangle( int x1, int x2, int x3, int y1, int y2, int y3, int x4, int y4 );
#endif